----------------------------------------------------------------------------------
-- www.posedge.ir
-- Mohsen Sadeghi Moghaddam
-- test on Megawing 
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity my_hw is
		port (
			DIP			:in std_logic_vector(7 downto 0);
			LED			:out std_logic_vector(7 downto 0);
			clock 		:in std_logic;
			segment 	:out bit_vector(7 downto 0);
			sel			:out bit_vector(3 downto 0) 
				);
				
end my_hw;

architecture Behavioral of my_hw is

	signal temp 		:std_logic := '0' ;
	signal sel_seg 		:bit_vector(3 downto 0):= "0111";
begin	
-------------clock divider----   1   ------------------------------
	process (clock)
	variable counter :integer:=0;
	begin
		if (clock'event and clock='1') then
			counter := counter +1;
			if (counter > 25000 ) then
				counter :=0;
				temp <= not temp;
			end if;
		end if;
	end process;

------------------------    2   ------------------------------------
	process (temp)
	begin
		if (temp'event and temp ='1') then
			sel_seg <= sel_seg ror 1 ;     	-- 0111 ==> 1011 ==> 1101 ==> 1110 ==>....
		end if;
	end process;

-----------------------    3    ----------------------------
	process (sel_seg)
	begin
		case sel_seg is
			when "1110"=>
				segment <= x"F9";	-- 1 	on 7_seg
			when "1101"=>
				segment <= x"B0";	-- 3	on 7_seg
			when "1011"=>
				segment <= x"90";	-- 9	on 7_seg
			when "0111"=>
				segment <= x"99";  	-- 4	on 7_seg
			when others =>
				segment <= x"FF";
		end case;
	end process;
----------------------     4   ------------------------------
	sel <= sel_seg;
	LED <= DIP ;

end Behavioral;

